// Copyright (c) 2004 pruet boonma <pruet@eng.cmu.ac.th>

import java.util.Timer;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class MindRhythm extends MIDlet
    implements CommandListener, ItemStateListener
{

    public MindRhythm()
    {
        setting = new Setting("MindRhythm");
        display = Display.getDisplay(this);
        mymindtimer = new mindTimer(this);
        mytimer = new Timer();
        createUI();
        state = true;
    }

    protected void createUI()
    {
        mainForm = new Form("MindRhythm ");
        String s = null;
        int i = 0;
        s = setting.get("type");
        if(s != null && s.length() > 0)
            i = Integer.parseInt(s);
        s = setting.get("period");
        if(s == null || s.length() == 0)
            s = "5";
        exitCommand = new Command("Exit", 7, 3);
        aboutCommand = new Command("About", 1, 2);
        stateCommand = new Command("Start", 4, 1);
        periodField = new TextField("Period(s)", s, 30, 2);
        statusTicker = new Ticker("Status: Stop");
        String as[] = {
            "Alarm", "Confirm", "Error", "Info", "Warning"
        };
        cg = new ChoiceGroup("Beep Sound", 1, as, null);
        cg.setSelectedIndex(i, true);
        mainForm.addCommand(aboutCommand);
        mainForm.addCommand(exitCommand);
        mainForm.addCommand(stateCommand);
        mainForm.append(periodField);
        mainForm.append(cg);
        mainForm.setTicker(statusTicker);
        mainForm.setCommandListener(this);
        mainForm.setItemStateListener(this);
        display.setCurrent(mainForm);
        setTimer();
    }

    public void timerTimeout()
    {
        if(!state)
        {
            Alert alert = null;
            int i = cg.getSelectedIndex();
            switch(i)
            {
            case 0: // '\0'
                alert = new Alert("", "", null, AlertType.ALARM);
                break;

            case 1: // '\001'
                alert = new Alert("", "", null, AlertType.CONFIRMATION);
                break;

            case 2: // '\002'
                alert = new Alert("", "", null, AlertType.ERROR);
                break;

            case 3: // '\003'
                alert = new Alert("", "", null, AlertType.INFO);
                break;

            default:
                alert = new Alert("", "", null, AlertType.WARNING);
                break;
            }
            alert.setTimeout(100);
            AlertType alerttype = alert.getType();
            alerttype.playSound(display);
            display.setCurrent(alert);
            setTimer();
        }
    }

    protected void setTimer()
    {
        mytimer.cancel();
        mymindtimer.cancel();
        mytimer = new Timer();
        mymindtimer = new mindTimer(this);
        String s = periodField.getString();
        if(s != null && s.length() > 0)
            mytimer.schedule(mymindtimer, Integer.parseInt(periodField.getString()) * 1000);
    }

    public void commandAction(Command command, Displayable displayable)
    {
        try
        {
            if(command.getCommandType() == 7)
                closeApp(false);
            else
            if(command == aboutCommand)
            {
                Alert alert = new Alert("MindRhythm 0.0.1", "Copyright (C) 2004, Pruet Boonma <pruet@eng.cmu.ac.th>\nGPL Applied", null, AlertType.INFO);
                alert.setTimeout(-2);
                display.setCurrent(alert);
            } else
            if(command == stateCommand)
            {
                String s = "";
                if(state)
                {
                    s = "Stop";
                    statusTicker.setString("Status: Start");
                } else
                {
                    s = "Start";
                    statusTicker.setString("Status: Stop");
                }
                mainForm.removeCommand(stateCommand);
                stateCommand = new Command(s, 4, 3);
                mainForm.addCommand(stateCommand);
                state = !state;
                setTimer();
            }
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
            Alert alert1 = new Alert("Exception", exception.getMessage(), null, AlertType.ERROR);
            alert1.setTimeout(-2);
            display.setCurrent(alert1);
        }
    }

    public void itemStateChanged(Item item)
    {
        try
        {
            setting.set("period", periodField.getString());
            setting.set("type", Integer.toString(cg.getSelectedIndex()));
            setTimer();
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
            Alert alert = new Alert("Exception", exception.getMessage(), null, AlertType.ERROR);
            alert.setTimeout(-2);
            display.setCurrent(alert);
        }
    }

    public void closeApp(boolean flag)
    {
        destroyApp(flag);
        notifyDestroyed();
    }

    public void startApp()
    {
        if(display == null)
        {
            display = Display.getDisplay(this);
            createUI();
        }
    }

    public void pauseApp()
    {
    }

    public void destroyApp(boolean flag)
    {
    }

    protected Display display;
    protected Setting setting;
    protected Form mainForm;
    protected TextField periodField;
    protected Ticker statusTicker;
    protected Command exitCommand;
    protected Command aboutCommand;
    protected Command stateCommand;
    protected ChoiceGroup cg;
    protected mindTimer mymindtimer;
    protected Timer mytimer;
    protected boolean state;
}
